/*  STRFILE.H - Include File defining the STRFILE structure
 *  (C) Copyright 1990 by E.Kappel. All Rights Reserved.
 *
 *  Release Notes:
 *  - Creation          : May 21, 1990
 *  - Last Modification : May 21, 1990
 *
 *  Version Notes:
 *  - 0.00 - May 21, 1990
 *
 *  Change History:
 *  - May 21, 1990 (/ek):
 *     - File creation from orignal version of ver 1.2 (Berkeley) 5/14/81
 *
 *  Bugs and limitations: (see TBC)
 *  - None.
 */

/************************************************************************/

#ifndef STRFILE_H
#define STRFILE_H

/************************************************************************/
/* Independent Constants
 */
#define MAXDELIMS       3

/* bits for flag field
 */
#define STR_RANDOM      0x1
#define STR_ORDERED     0x2

/************************************************************************/
/* Types
 */
/* string file information table
 */
typedef struct {
   LongWord       numstr;               /* # of strings in the file */
   LongWord       longlen;              /* length of longest string */
   LongWord       shortlen;             /* length of shortest string */
   LongWord	  delimmark[MAXDELIMS]; /* delimiter markings */
   SignedLongWord delimpos[MAXDELIMS];  /* delimiter positions */
   Word           flags;                /* bit field for flags */
} STRFILE;

/************************************************************************/
/* Variables
 */

/************************************************************************/
/* Function Prototypes
 */

/************************************************************************/

#endif

/************************************************************************/
